#include "stm32f0xx_usart.h"
#include "stm32f0xx_misc.h"

void uartEVROpen(USART_TypeDef* USARTx, uint32_t baud) {
	
	GPIO_InitTypeDef serija;
	USART_InitTypeDef serial;
	//NVIC_InitTypeDef serial_interrupt;
	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);
	
	//TX & RX: AF, OType_PP, PuPd_UP (or for RX: OType_OD, PuPd_NONE)
	GPIO_StructInit(&serija);
	serija.GPIO_Pin = GPIO_Pin_9 | GPIO_Pin_10;
	serija.GPIO_Mode = GPIO_Mode_AF;
	serija.GPIO_PuPd = GPIO_PuPd_UP;
	serija.GPIO_Speed = GPIO_Speed_Level_2;
	GPIO_Init(GPIOA, &serija);
	
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_1);
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_1);
	
	//UART1 config
	USART_StructInit(&serial);
	serial.USART_BaudRate = baud;
	serial.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USARTx, &serial);
	
	/*
	//NVIC config (for interrupt)
	serial_interrupt.NVIC_IRQChannel = USART1_IRQn;
	serial_interrupt.NVIC_IRQChannelPriority = 3;
	serial_interrupt.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&serial_interrupt);
	
	USART_ITConfig(USARTx, USART_IT_RXNE, ENABLE); */
	USART_Cmd(USARTx, ENABLE);
	
	}

void uartPCOpen(USART_TypeDef* USARTx, uint32_t baud) {
	
	GPIO_InitTypeDef serija;
	USART_InitTypeDef serial;
	//NVIC_InitTypeDef serial_interrupt;
	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);
	
	//TX & RX: AF, OType_PP, PuPd_UP (or for RX: OType_OD, PuPd_NONE)
	GPIO_StructInit(&serija);
	serija.GPIO_Pin = GPIO_Pin_2 | GPIO_Pin_3;
	serija.GPIO_Mode = GPIO_Mode_AF;
	serija.GPIO_PuPd = GPIO_PuPd_UP;
	serija.GPIO_Speed = GPIO_Speed_Level_2;
	GPIO_Init(GPIOA, &serija);
	
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource2, GPIO_AF_1);
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource3, GPIO_AF_1);
	
	//UART2 config
	USART_StructInit(&serial);
	serial.USART_BaudRate = baud;
	serial.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USARTx, &serial);
	
	//NVIC config (for interrupt) - ne treba za sada
	/*serial_interrupt.NVIC_IRQChannel = USART2_IRQn;
	serial_interrupt.NVIC_IRQChannelPriority = 3;
	serial_interrupt.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&serial_interrupt);
	
	USART_ITConfig(USARTx, USART_IT_RXNE, ENABLE);*/
	USART_Cmd(USARTx, ENABLE);
	
	}
	
	
void uartClose(USART_TypeDef* USARTx) {
		
	USART_Cmd(USARTx, DISABLE);
	
	}


void uartPutString(volatile char *c, USART_TypeDef* USARTx) {
	
		while(*c) {
			while(USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET);
			
			USART_SendData(USARTx, *c);
			
			*c++;
			}
	}
	
	
int uartGetc(USART_TypeDef* USARTx) {
	
	while(USART_GetFlagStatus(USARTx, USART_FLAG_RXNE) == RESET);
	
	return USART_ReceiveData(USARTx);
	
	}

void uartSendInt(uint8_t *c, USART_TypeDef* USARTx) {
	
	while(USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET);
	USART_SendData(USARTx, *c);
	
	}
