#include "nRF24L01_test.h"
#include "nRF24L01.h"
#include "stdio.h"
#include "uart.h"
#include "main.h"
#include "string.h"
#include "WTV020SD.h"

#define buffLen 64

//
//slanje poruke
//
void testUnidirectionalMessagingTxOne(void) {
	
	char txBuff[buffLen] = "";
	
	//Inicijaliziraj nRF
	nRF24L01_initializeDebug(0, 32, 0); //(Tx mode, payload = 32 bytes, autoAck = disable)
	nRF24L01_clearFlush();
	
	sprintf(txBuff, "Hello world! ");
	
	while (1) {
		
		//posalji paket
		nRF24L01_writeTxPayload(txBuff, 32, 1);
		
		//posalji na UART da je poslano
		uart_put_string("Poruka poslana ", USART1);
		
		//pricekaj sekundu
		delay_10us(100000);
		}
	}

//
//Slanje vise poruka
//
void testUnidirectionalMessagingTxMore(void) {
	
	char txBuff[buffLen] = "";
	uint32_t period = 10;
	uint32_t counter = 0;
	uint32_t time = 0;
	float bps;
	
	nRF24L01_initializeDebug(0, 32, 0);  //(Tx mode, payload = 32 bytes, autoAck disabled)
	nRF24L01_clearFlush();
	
	sprintf(txBuff, "Hello world! ");
	
	while(1) {
		
		nRF24L01_writeTxPayload(txBuff, 32, 1);
		counter += (32 * 8);
		
		uart_put_string("Poruka poslana ", USART1);
		
		delay_10us(100000); //1s
		time += period;
		bps = ((float)counter) / (((float)time) / 1000.0f);
		sprintf(txBuff, "bps=%5.2f  ", bps);
		}
	}

//
//primanje poruke
//
void testUnidirectionalMessagingRx(void) {
	
	unsigned char rxBuff[buffLen];
	//char temp[buffLen];
	char temp=0;
	
	//inicijaliziraj nRF
	nRF24L01_initializeDebug(1, 32, 0);  //(Rx mode, payload = 32, autoAck = disable)
	nRF24L01_clearFlush();
	
	//napisi na UART da je u stanju cekanja
	uart_put_string("Cekanje poruke... ", USART1);
	
	while (1)
	{
		//pogledaj jel ima sto u Rx bufferu
		if(nRF24L01_irqRxDrActive()) {
			
			//ako ima izvuci paket
			nRF24L01_readRxPayload(rxBuff, 32);
			//ocisti interrupt u nRFu
			nRF24L01_irqClearAll();
			
			//napisi paket na seriju
			//strncpy(&temp, rxBuff[0], 32);
			temp = rxBuff[0];
			uart_put_string(&temp, USART1);
			
			if(rxBuff[0] == 53) {
					WTV20SD_playVoice(0);
					uart_put_string("Glazba upali! ", USART1);
			}	
			else if(rxBuff[0] == 54) {
					WTV20SD_stopVoice();
					uart_put_string("Glazba ugasi !", USART1);
			}
			else if(rxBuff[0] == 55) {
					GPIO_SetBits(GPIOC, GPIO_Pin_7);
					uart_put_string("Svjetlo upali! ", USART1);
				}
			else if(rxBuff[0] == 56) {
					GPIO_ResetBits(GPIOC, GPIO_Pin_7);
					uart_put_string("Svjetlo ugasi! ", USART1);
				}
			}
		}
	}
