#include "spi.h"
#include "stm32f0xx_gpio.h"

void spi_nrfInit(void) {
	
	SPI_InitTypeDef SPI_nrfStruct;
	GPIO_InitTypeDef GPIO_nrfStruct;
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA|RCC_AHBPeriph_GPIOC, ENABLE);
	
	//PA5 - SCK, PA6 - MISO, PA7 - MOSI
	GPIO_nrfStruct.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
	GPIO_nrfStruct.GPIO_Mode = GPIO_Mode_AF;
	GPIO_nrfStruct.GPIO_OType = GPIO_OType_PP;
	GPIO_nrfStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_nrfStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_nrfStruct);
	
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource5, GPIO_AF_0);
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource6, GPIO_AF_0);
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource7, GPIO_AF_0);
	
	//PC1 - NSS
	GPIO_nrfStruct.GPIO_Pin = GPIO_Pin_1;
	GPIO_nrfStruct.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_nrfStruct.GPIO_OType = GPIO_OType_PP;
	GPIO_nrfStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_nrfStruct);
	
	//Za CE pin
	GPIO_nrfStruct.GPIO_Pin = GPIO_Pin_0;
	GPIO_nrfStruct.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_nrfStruct.GPIO_OType = GPIO_OType_PP;
	GPIO_nrfStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_nrfStruct);
	
	//Za IRQ pin
	GPIO_nrfStruct.GPIO_Pin = GPIO_Pin_2;
	GPIO_nrfStruct.GPIO_Mode = GPIO_Mode_IN;
	GPIO_nrfStruct.GPIO_OType = GPIO_OType_PP;
	GPIO_nrfStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_nrfStruct);
	
	//SPI1 Configuration
	SPI_Cmd(SPI1, DISABLE);
	SPI_nrfStruct.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_nrfStruct.SPI_Mode = SPI_Mode_Master;
	SPI_nrfStruct.SPI_DataSize = SPI_DataSize_8b;
	SPI_nrfStruct.SPI_CPOL = SPI_CPOL_Low;
	SPI_nrfStruct.SPI_CPHA = SPI_CPHA_1Edge;
	SPI_nrfStruct.SPI_NSS = SPI_NSS_Soft;
	SPI_nrfStruct.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;
	SPI_nrfStruct.SPI_FirstBit = SPI_FirstBit_MSB;
	SPI_nrfStruct.SPI_CRCPolynomial = 7;
	SPI_Init(SPI1, &SPI_nrfStruct);
	SPI_RxFIFOThresholdConfig(SPI1, SPI_RxFIFOThreshold_QF);
	SPI_Cmd(SPI1, ENABLE);
}
